#include "Plotstream.h"
#include <cmath>

//template<class T> bool std::isfinite(T v) {return !!_finite(v);}
template<class T> T round(T v) {return ::floor(v+0.5);}
template<class T> T trunc(T v) {return (T)(int)v;}
template<class T> T remquo(T a, T b,int*c) {
 if (c) *c=int(a/b);
 return fmod(a,b);
}

template<class T> LRESULT CALLBACK PlotWindowProc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam) {
 Plotstream<T>*ps=(Plotstream<T>*)GetWindowLongPtr(wnd,0);
 switch (msg) {
  case WM_NCCREATE: {
   CREATESTRUCT*cs=(CREATESTRUCT*)lParam;
   ps=(Plotstream<T>*)cs->lpCreateParams;
   SetWindowLongPtr(wnd,0,(LPARAM)ps);
   ps->wnd=wnd;
  }break;
  case WM_PAINT: {
   PAINTSTRUCT s;
   BeginPaint(wnd,&s);
   ps->dc=s.hdc;
   ps->onPaint();
   EndPaint(wnd,&s);
  }return 0;
  case WM_PRINTCLIENT: {
   ps->dc=(HDC)wParam;
   ps->onPaint();
  }return 0;
  case WM_KEYDOWN: switch (wParam) {
   case VK_ESCAPE: DestroyWindow(wnd); break;
   case VK_SPACE: PostQuitMessage(2); break;
  }break;
  case WM_LBUTTONDOWN: PostQuitMessage(1); break;
  case WM_CLOSE: DestroyWindow(wnd); break;
  case WM_DESTROY: PostQuitMessage(0); break;
  case WM_NCDESTROY: ps->wnd=0; break;
 }
 return DefWindowProc(wnd,msg,wParam,lParam);
}

template<class T>struct initializer{
 initializer(const TCHAR*classname);
};

static initializer<double> koolplot_double("koolplot<double>");
static initializer<float> koolplot_float("koolplot<float>");
static initializer<satint<long>> koolplot_long("koolplot<long>");
static initializer<satint<short>> koolplot_short("koolplot<short>");

template<class T>initializer<T>::initializer(const TCHAR*classname) {
 WNDCLASS wc;
 memset(&wc,0,sizeof wc);
 wc.style=CS_HREDRAW|CS_VREDRAW/*|CS_DBLCLKS*/;
 wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
 wc.hCursor=LoadCursor(0,IDC_ARROW);
 wc.hIcon=LoadIcon(0,IDI_APPLICATION);
 wc.cbWndExtra=sizeof(void*);
 wc.lpfnWndProc=PlotWindowProc<T>;
 wc.lpszClassName=classname;
 RegisterClass(&wc);
}